'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

exports.default = createShallow;

var _jss = require('jss');

var _jssPresetDefault = require('jss-preset-default');

var _jssPresetDefault2 = _interopRequireDefault(_jssPresetDefault);

var _jssThemeReactor = require('jss-theme-reactor');

var _enzyme = require('enzyme');

var _theme = require('../styles/theme');

var _theme2 = _interopRequireDefault(_theme);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Generate an enhanced shallow function with the needed context.
function createShallow() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var _options$shallow = options.shallow,
      shallow = _options$shallow === undefined ? _enzyme.shallow : _options$shallow,
      _options$otherContext = options.otherContext,
      otherContext = _options$otherContext === undefined ? {} : _options$otherContext,
      _options$dive = options.dive,
      dive = _options$dive === undefined ? false : _options$dive;

  var theme = (0, _theme2.default)();
  var jss = (0, _jss.create)((0, _jssPresetDefault2.default)());
  var styleManager = (0, _jssThemeReactor.createStyleManager)({ jss: jss, theme: theme });
  var context = (0, _extends3.default)({
    styleManager: styleManager
  }, otherContext);
  var shallowWithContext = function shallowWithContext(node) {
    var options2 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    var wrapper = shallow(node, {
      context: (0, _extends3.default)({}, context, options2.context)
    });

    if (dive) {
      return wrapper.dive();
    }

    return wrapper;
  };

  shallowWithContext.context = context;

  return shallowWithContext;
} //  weak